import datetime
import urllib
import csv
from selenium import webdriver
from selenium.common.exceptions import NoSuchElementException
from selenium.common.exceptions import TimeoutException

# pURLBp[^{}
URL_MERCARI = 'https://www.mercari.com/jp/search/?sort_order=price_asc&keyword={}&status_on_sale=1' # J
URL_RAKUMA = 'https://fril.jp/search/{}?order=asc&sort=sell_price&transaction=selling' # N}

# ňl̗vf擾pZN^
SELECTOR_MERCARI = '.items-box-price' # J
SELECTOR_RAKUMA = '.item-box__item-price' # N}

CAT_CHAR = ' ' # ANDL[[hAp
NOT_CHAR = '-' # NOTL[[h̖`ɕt^镶BN}͖Ή
DATA_FILE = 'data.csv' # CSVt@C

# L[[h
keywords_all = [
    {
        'and': ['Ibanez', 'TS-9'],
        'not': ['TS9DX', '808', 'TS5']
    },
    {
        'and': ['Ibanez', 'RG350'],
        'not': ['WN']
    },
    {
        'and': ['BOSS', 'GT-1', 'GtFN^['],
        'not': ['GT-10', 'GT-100', 'GT-1000', 'GT-1B', 'ACA_v^', 'ȏ']
    },
]

def get_min_price(browser, base_url, query_params, selector):
    """w肵L[[h̏i̍ňl擾
    :param browser: uEU
    :param base_url: pURL
    :param query_params: AL[[h
    :param selector: i̗vf̃ZN^
    :return: ňl̕
    """
    # 擾i̗]vȕ폜p
    dic = str.maketrans({
        '\': '',
        '': '',
        ',': '',
        ' ': '',
    })

    # L[[hGR[hAURLɖߍŃANZX
    url = base_url.format(urllib.parse.quote(query_params))

    try:
        # ňl̗vf擾ĕԂ
        browser.get(url)
        elm_min = browser.find_element_by_css_selector(selector)
    except NoSuchElementException as e:
        print(f'w肵vf܂ł:{e.args}')
    except TimeoutException as e:
        print(f'ǂݍ݂^CAEg܂:{e.args}')

    return(elm_min.text.translate(dic)) # ]vȕ폜ĂԂ

# uEU
browser = webdriver.Chrome('chromedriver.exe')
browser.set_page_load_timeout(30) # ǂݍ݃^CAEgݒ

# CSVۑpXgp
record = []

# s̓t擾E񉻂ĕۑpXgɒǉ
record.append(datetime.date.today().strftime('%Y/%m/%d'))

# iƂɍňl擾
for keywords in keywords_all:
    # iƂ̌L[[hA
    query_params_and = CAT_CHAR.join(keywords['and']) # ANDp
    query_params_not = CAT_CHAR.join([NOT_CHAR + kw for kw in keywords['not']]) # NOTp

    # J̍ňl擾AۑpXgɒǉB
    query_params_mercari = query_params_and + CAT_CHAR + query_params_not
    min_price = get_min_price(browser, URL_MERCARI, query_params_mercari, SELECTOR_MERCARI)
    record.append(min_price)

    # N}̍ňl擾AۑpXgɒǉ
    query_params_rakuma = query_params_and # AND̂
    min_price = get_min_price(browser, URL_RAKUMA, query_params_rakuma, SELECTOR_RAKUMA)
    record.append(min_price)

browser.quit() # uEUI

# CSVɏ
try:
    with open(DATA_FILE, 'a', newline='') as f:
        writer = csv.writer(f, delimiter=',')
        writer.writerow(record)
except OSError as e:
    print(f't@CŃG[:{e.args}')
